## python3.4 3.4.2

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python
SPHINXBUILD  = sphinx-build
SPHINXOPTS   =
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/sphinxext/patchlevel.py)

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_paper_size=$(PAPER) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/sphinxext/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now copy build/pydoc-topics/topics.py" \
	      "to ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/*

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

check:
	$(PYTHON) tools/rstlint.py -i tools

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='-A daily=1 -A versionswitcher=1'
	-make suspicious

# for quick rebuilds (HTML only)
autobuild-html:
	make html SPHINXOPTS='-A daily=1 -A versionswitcher=1'

# for stable releases: only build if not in pre-release stage (alpha, beta, rc)
autobuild-stable:
	@case $(DISTVERSION) in *[abc]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

=== debian/changelog ===
python3.4 (3.4.2-4) unstable; urgency=medium

  * Fix issue #22935: Fix ssl module when SSLv3 protocol is not supported.
  * Fix issue #16043: Add a default limit for the amount of data
    xmlrpclib.gzip_decode will return. CVE-2013-1753. Closes: #742927.
  * Disable ensurepip for the system installation, only enable it for virtual
    environments. Closes: #772730.

 -- Matthias Klose <doko@debian.org>  Sat, 27 Dec 2014 12:23:33 +0100

python3.4 (3.4.2-3) unstable; urgency=medium

  * Update to 20141202 from the 3.4 branch.
    - Issue #20335: bytes constructor now raises TypeError when encoding or
      errors is specified with non-string argument.
    - Issue #21971: Update turtledemo doc and add module to the index.
    - Issue #21032. Fixed socket leak if HTTPConnection.getresponse() fails.
    - Issue #22960: Add a context argument to xmlrpclib.ServerProxy constructor.
    - Issue #22915: SAX parser now supports files opened with file descriptor
      or bytes path.
    - Issue #22609: Constructors and update methods of mapping classes in the
      collections module now accept the self keyword argument.
    - Issue #22788: Add *context* parameter to logging.handlers.HTTPHandler.
    - Issue #22921: Allow SSLContext to take the *hostname* parameter even if
      OpenSSL doesn't support SNI.
    - Issue #22894: TestCase.subTest() would cause the test suite to be stopped
      when in failfast mode, even in the absence of failures.
    - Issue #22638: SSLv3 is now disabled throughout the standard library.
      It can still be enabled by instantiating a SSLContext manually.
    - Issue #22370: Windows detection in pathlib is now more robust.
    - Issue #22841: Reject coroutines in asyncio add_signal_handler().
    - Issue #22838: All test_re tests now work with unittest test discovery.
    - Issue #21514: The documentation of the json module now refers to new
      JSON RFC 7159 instead of obsoleted RFC 4627.
    - Issue #22314: pydoc now works when the LINES environment variable is set.
    - IDLE updates.
  * Fix byte-code removal for the __phello__ module (mismatching source
    and byte-code file name). Closes: #769769.
  * Let ensurepip use a temporary location for the copy of the wheels.
    Remove the ad-hoc /usr/lib/python-wheels location on package purge.
    Let python3.4-venv break python3-pip (<< 1.5.6-4).  Closes: #769449.
  * Don't pass default compiler search directories in the pkgconfig file.
    Closes: #770936.
  * Don't run pyexpat.test_exception as an autopkg test, requires a source
    file.
  * Allow building and testing without SSLv3 support (Kurt Roeckx).
    Addresses: #768611.
  * Fix issue 22966, when byte compiling, keep the base name of a file
    containing dots. Closes: #769769.

 -- Matthias Klose <doko@debian.org>  Tue, 02 Dec 2014 14:39:00 +0100

python3.4 (3.4.2-2) unstable; urgency=medium

  * Repackage the upstream source without the bundled ensurepip wheels (using
    package format 3.0 (quilt)).
  * Update to 20141112 from the 3.4 branch.
    - Issue #19524: Fixed resource leak in the HTTP connection when an invalid
      response is received.
    - Issue #22216: smtplib now resets its state more completely after a quit.
      The most obvious consequence of the previous behavior was a STARTTLS
      failure during a connect/starttls/quit/connect/starttls sequence.
    - Issue #22185: Fix an occasional RuntimeError in threading.Condition.wait()
      caused by mutation of the waiters queue without holding the lock.
    - Issue #22182: Use e.args to unpack exceptions correctly in
      distutils.file_util.move_file.
    - The webbrowser module now uses subprocess's start_new_session=True rather
      than a potentially risky preexec_fn=os.setsid call.
    - Issue #22191: Fix warnings.__all__.
    - Issue #8797: Raise HTTPError on failed Basic Authentication immediately.
    - Issue #21166: Prevent possible segfaults and other random failures of
      python --generate-posix-vars in pybuilddir.txt build target.
    - Idle changes:
      - Issue #17390: Adjust Editor window title; remove 'Python',
        move version to end.
      - Issue #14105: Idle debugger breakpoints no longer disappear
        when inseting or deleting lines.
      - Issue #17172: Turtledemo can now be run from Idle.
      - Issue #22236: Tkinter tests now don't reuse default root window.
        New root window is created for every test class.
    - Tk changes:
      - Issue #22226: First letter no longer is stripped from the "status" key
        in the result of Treeview.heading().
      - Issue #22051: turtledemo no longer reloads examples to re-run them.
        Initialization of variables and gui setup should be done in main(),
        which is called each time a demo is run, but not on import.
      - Issue #21933: Turtledemo users can change the code font size with a
        menu selection or control(command) '-' or '+' or control-mousewheel.
      - Issue #21597: The separator between the turtledemo text pane and the
        drawing canvas can now be grabbed and dragged with a mouse.  The code
        text pane can be widened to easily view or copy the full width of the
        text.
        The canvas can be widened on small screens.
      - Issue #18132: Turtledemo buttons no longer disappear when the window
        is shrunk.
      - Issue #22236: Fixed Tkinter images copying operations in NoDefaultRoot
        mode.
  * Fix maintainer scripts for byte-code removal. Closes: #769079.

 -- Matthias Klose <doko@debian.org>  Thu, 13 Nov 2014 04:33:52 +0100

python3.4 (3.4.2-1) unstable; urgency=medium

  * Python 3.4.2 release.
  * Refresh patches.
  * Bump standards version to 3.9.6.

 -- Matthias Klose <doko@debian.org>  Wed, 08 Oct 2014 11:25:34 +0200

python3.4 (3.4.2~rc1-1) unstable; urgency=medium

  * Python 3.4.2 release candidate 1.
  * Update to 20140930 from the 3.4 branch.

 -- Matthias Klose <doko@debian.org>  Tue, 30 Sep 2014 01:51:50 +0200



=== debian/control ===
Source: python3.4
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 5.0.51~), dpkg-dev (>= 1.17.11),
  gcc (>= 4:4.9.2),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline6-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.4),
  libbluetooth-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  locales [!armel !avr32 !hppa !ia64 !mipsel],
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  mime-support, netbase, bzip2, python3:any,
  net-tools, xvfb, xauth
Build-Depends-Indep: python-sphinx
Standards-Version: 3.9.6
Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.4-debian
Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.4-debian
XS-Testsuite: autopkgtest

Package: python3.4
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.4-minimal (= ${binary:Version}), libpython3.4-stdlib (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.4-venv, python3.4-doc, binutils
Description: Interactive high-level object-oriented language (version 3.4)
 Python is a high-level, interactive, object-oriented language. Its 3.4 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.4-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.4 (= ${binary:Version}),
 python-setuptools-whl, python-pip-whl, ${shlibs:Depends}, ${misc:Depends}
Replaces: python3.4 (<< 3.4.1)
Breaks: python3-pip.4 (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.4)
 Python is a high-level, interactive, object-oriented language. Its 3.4 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.4 binary.

Package: libpython3.4-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: multiarch-support
Depends: libpython3.4-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Description: Interactive high-level object-oriented language (standard library, version 3.4)
 Python is a high-level, interactive, object-oriented language. Its 3.4 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.4's standard library. It is normally not
 used on its own, but as a dependency of python3.4.

Package: python3.4-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.4-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.4
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.4)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.4-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython3.4-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: multiarch-support
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.4-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Replaces: libpython3.4-stdlib (<< 3.4.0+20140425-1)
Description: Minimal subset of the Python language (version 3.4)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.4-minimal.

Package: libpython3.4
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: multiarch-support
Depends: libpython3.4-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.4)
 Python is a high-level, interactive, object-oriented language. Its 3.4 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.4-examples
Architecture: all
Depends: python3.4 (>= ${source:Version}), ${misc:Depends}
Replaces: libpython3.4-testsuite (<< 3.4.1-8~)
Description: Examples for the Python language (v3.4)
 Examples, Demos and Tools for Python (v3.4). These are files included in
 the upstream Python distribution (v3.4).

Package: python3.4-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.4 (= ${binary:Version}), libpython3.4-dev (= ${binary:Version}), libpython3.4 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.4)
 Header files, a static library and development tools for building
 Python (v3.4) modules, extending the Python interpreter or embedding
 Python (v3.4) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.4-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: multiarch-support
Depends: libpython3.4-stdlib (= ${binary:Version}), libpython3.4 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.4)
 Header files, a static library and development tools for building
 Python (v3.4) modules, extending the Python interpreter or embedding
 Python (v3.4) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.4-dev.

Package: libpython3.4-testsuite
Section: libdevel
Architecture: all
Depends: python3.4 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.4)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.4-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.4-stdlib package).

Package: idle-python3.4
Architecture: all
Depends: python3.4, python3-tk, python3.4-tk, ${misc:Depends}
Enhances: python3.4
Description: IDE for Python (v3.4) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.4).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.4-doc
Section: doc
Architecture: all
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.4
Description: Documentation for the high-level object-oriented language Python (v3.4)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.4). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.4
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.4-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Priority: extra
Depends: python3.4 (= ${binary:Version}), libpython3.4-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.4)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.4-dbg
Section: debug
Architecture: any
Multi-Arch: same
Priority: extra
Pre-Depends: multiarch-support
Depends: libpython3.4-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug Build of the Python Interpreter (version 3.4)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
    WITHOUT_STONE := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
  WITHOUT_STONE := yes
endif

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)

VER=3.4
SVER=3.4.2
NVER=3.5
PVER=python3.4
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  with_fpectl = yes
  #with_udeb = yes
else
  PY_MINPRIO = $(PY_PRIO)
  with_fpectl = yes
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifneq (,$(filter $(distrelease),sid experimental))
  bd_gcc = gcc (>= 4:4.9.1-1),
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CPPFLAGS:= $(shell dpkg-buildflags --get CPPFLAGS)
DPKG_CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
DPKG_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-O0,$(DPKG_CFLAGS))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el))
  with_lto := yes
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg
p_udeb	:= $(PVER)-udeb
p_venv	:= $(PVER)-venv

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev
p_ldbg	:= lib$(PVER)-dbg
p_ltst	:= lib$(PVER)-testsuite

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)
d_lib	:= debian/$(p_lib)
d_tk	:= debian/$(p_tk)
d_dev	:= debian/$(p_dev)
d_exam	:= debian/$(p_exam)
d_idle	:= debian/$(p_idle)
d_doc	:= debian/$(p_doc)
d_dbg	:= debian/$(p_dbg)
d_udeb	:= debian/$(p_udeb)
d_venv	:= debian/$(p_venv)

d_lbase	:= debian/$(p_lbase)
d_lmin	:= debian/$(p_lmin)
d_ldev	:= debian/$(p_ldev)
d_ldbg	:= debian/$(p_ldbg)
d_ltst	:= debian/$(p_ltst)

build-arch: stamps/stamp-build
build-indep: stamps/stamp-build-doc
build: build-arch
stamps/stamp-build: stamps/stamp-build-static stamps/stamp-mincheck \
    stamps/stamp-build-shared stamps/stamp-build-debug \
    stamps/stamp-build-shared-debug \
    stamps/stamp-check stamps/stamp-pystone stamps/stamp-pybench
	touch $@

PROFILE_EXCLUDES = test_compiler test_distutils test_subprocess \
	test_multiprocessing test_socketserver \
	test_thread test_threaded_import test_threadedtempfile \
	test_threading test_threading_local test_threadsignals \
	test_concurrent_futures test_ctypes \
	test_dbm_dumb test_dbm_ndbm test_pydoc test_sundry \
	test_signal test_ioctl test_gdb test_ensurepip test_venv

# FIXME: these fail in the profile build
PROFILE_EXCLUDES += \
	test_cmd_line_script test_zipimport_support

# FIXME: update profiled-build.diff to support --next
#       --next=20
PROFILE_TASK = ../Lib/test/regrtest.py \
	-s \
	-j 1 -unone,decimal \
	-x $(sort $(TEST_EXCLUDES) $(PROFILE_EXCLUDES))

stamps/stamp-build-static: stamps/stamp-configure-static
	dh_testdir
	$(MAKE) $(NJOBS) -C $(buildd_static) \
		EXTRA_CFLAGS="$(EXTRA_OPT_CFLAGS)" \
		PROFILE_TASK='$(PROFILE_TASK)' $(make_build_target)

	: # check that things are correctly built
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))

## python3.4 3.4.3

=== debian/changelog ===
python3.4 (3.4.3-1ubuntu1~14.04.7) trusty-security; urgency=medium

  * SECURITY UPDATE: command injection in shutil module
    - debian/patches/CVE-2018-1000802.patch: use subprocess rather than
      distutils.spawn in Lib/shutil.py.
    - CVE-2018-1000802
  * SECURITY UPDATE: DoS via catastrophic backtracking
    - debian/patches/CVE-2018-106x.patch: fix expressions in
      Lib/difflib.py, Lib/poplib.py. Added tests to
      Lib/test/test_difflib.py, Lib/test/test_poplib.py.
    - CVE-2018-1060
    - CVE-2018-1061
  * SECURITY UPDATE: incorrect Expat hash salt initialization
    - debian/patches/CVE-2018-14647.patch: call SetHashSalt in
      Include/pyexpat.h, Modules/_elementtree.c, Modules/pyexpat.c.
    - CVE-2018-14647

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 12 Nov 2018 09:06:13 -0500

python3.4 (3.4.3-1ubuntu1~14.04.6) trusty-security; urgency=medium

  * SECURITY UPDATE: integer overflow in the PyBytes_DecodeEscape
    function
    - debian/patches/CVE-2017-1000158.patch: fix this integer overflow
      in Objects/bytesobject.c.
    - CVE-2017-1000158

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Thu, 23 Nov 2017 12:42:11 -0300

python3.4 (3.4.3-1ubuntu1~14.04.5) trusty-security; urgency=medium

  * SECURITY UPDATE: StartTLS stripping attack
    - debian/patches/CVE-2016-0772.patch: raise an error when
      STARTTLS fails in Lib/smtplib.py.
    - CVE-2016-0772
  * SECURITY UPDATE: use of HTTP_PROXY flag supplied by attacker in CGI
    scripts (aka HTTPOXY attack)
    - debian/patches/CVE-2016-1000110.patch: if running as CGI
      script, forget HTTP_PROXY in Lib/urllib.py, add test to
      Lib/test/test_urllib.py, add documentation.
    - CVE-2016-1000110
  * SECURITY UPDATE: Integer overflow when handling zipfiles
    - debian/patches/CVE-2016-5636-pre.patch: check for negative size in
      Modules/zipimport.c
    - debian/patches/CVE-2016-5636.patch: check for too large value in
      Modules/zipimport.c
    - CVE-2016-5636
  * SECURITY UPDATE: CRLF injection vulnerability in the
    HTTPConnection.putheader
    - debian/patches/CVE-2016-5699.patch: disallow newlines in
      putheader() arguments when not followed by spaces or tabs in
      Lib/httplib.py, add tests in Lib/test/test_httplib.py
    - CVE-2016-5699

 -- Steve Beattie <sbeattie@ubuntu.com>  Wed, 16 Nov 2016 12:38:40 -0800

python3.4 (3.4.3-1ubuntu1~14.04.4) trusty-proposed; urgency=medium

  * SRU: LP: #1620754: Fix invalid code in pyhash/siphash24. Issue #28055.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Sep 2016 10:26:44 +0200

python3.4 (3.4.3-1ubuntu1~14.04.3) trusty; urgency=medium

  * Remove the config file from the package, as there is no handling in
    place to deal with this config file on upgrade and it is not appropriate
    for inclusion in an urgent SRU.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 14 Oct 2015 12:52:19 -0700

python3.4 (3.4.3-1ubuntu1~14.04.2) trusty-proposed; urgency=medium

  * SRU: LP: #1348954.
  * Disable PEP 476 certificate verification, restoring the behaviour to
    the same as found in the 3.4.0 release included in 14.04 LTS.
    Make the default HTTPS certificate verification setting configurable
    using a config file /etc/python3.4/cert-verification.conf.
    The config file and the possibility to configure the default behaviour
    are removed on upgrades to Ubuntu 15.04 or newer releases.
  * Provide some user-friendly advice when `python3 -m venv` fails because the
    python3-venv package is not installed (Barry Warsaw).

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Oct 2015 14:37:09 +0200

python3.4 (3.4.3-1ubuntu1~14.04.1) trusty-proposed; urgency=medium

  * Backport issue #23844 from the 3.4 branch, replacing the 512 bit dh key
    with a 1024 bit one. Triggered by OpenSSL security update in
    trusty-security. LP: #1264554.
  * Fix expansion of makefile macros for _sysconfigdata. Issue #24705.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 28 Jul 2015 15:37:57 +0200

python3.4 (3.4.3-1ubuntu1~14.04) trusty-proposed; urgency=medium

  * SRU: Update Python3 for trusty. LP: #1348954.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Jun 2015 14:18:26 +0200

python3.4 (3.4.3-1ubuntu1) vivid; urgency=medium

  * debian/tests: Use init system agnostic "service" command instead of
    upstart specific "stop". Also drop unnecessary "status" call right after
    stopping apport.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Sun, 08 Mar 2015 10:46:59 +0100

python3.4 (3.4.3-1) experimental; urgency=medium

  * Python 3.4.3 release.
  * Changes since 20141202 (3.4.2-4):
    - Issue #22896: Avoid using PyObject_AsCharBuffer(),
      PyObject_AsReadBuffer(), and PyObject_AsWriteBuffer().
    - Issue #21295: Revert some changes (issue #16795) to AST line numbers and
      column offsets that constituted a regression.
    - Issue #21408: The default __ne__() now returns NotImplemented if __eq__()
      returned NotImplemented.
    - Issue #23321: Fixed a crash in str.decode() when error handler returned
      replacment string longer than mailformed input data.
    - Issue #23048: Fix jumping out of an infinite while loop in the pdb.
    - Issue #23165: Perform overflow checks before allocating memory in the
      _Py_char2wchar function.
    - Issue #23099: Closing io.BytesIO with exported buffer is rejected now to
      prevent corrupting exported buffer.
    - Issue #23363: Fix possible overflow in itertools.permutations.
    - Issue #23364: Fix possible overflow in itertools.product.
    - Issue #23366: Fixed possible integer overflow in itertools.combinations.
    - Issue #23369: Fixed possible integer overflow in
      _json.encode_basestring_ascii.
    - Issue #23353: Fix the exception handling of generators in
      PyEval_EvalFrameEx(). At entry, save or swap the exception state even if
      PyEval_EvalFrameEx() is called with throwflag=0. At exit, the exception


=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: python3.4
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 5.0.51~), dpkg-dev (>= 1.17.11),
-  gcc (>= 4:4.9.2),
+Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Build-Depends: debhelper (>= 5.0.51~), 
   quilt, autoconf,
   lsb-release, sharutils,
   libreadline6-dev, libncursesw5-dev (>= 5.3), 
@@ -87,6 +87,7 @@
 Recommends: libpython3.4-stdlib
 Conflicts: binfmt-support (<< 1.1.2)
 Replaces: libpython3.4-stdlib (<< 3.4.0+20140425-1)
+Breaks: python3-urllib3 (<< 1.7.1-1ubuntu4)
 Description: Minimal subset of the Python language (version 3.4)
  This package contains some essential modules. It is normally not
  used on it's own, but as a dependency of python3.4-minimal.

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, locales, python3.4-dev, libpython3.4-testsuite, python3-gdbm
# need to turn off apport
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential, locales, python3.4-dev, python3.4-dbg, libpython3.4-testsuite, python3-gdbm-dbg, gdb
# need to turn off apport
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential, locales, python3.4-dev, libpython3.4-testsuite, python3-gdbm
# need to turn off apport
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential, locales, python3.4-dev, python3.4-dbg, libpython3.4-testsuite, python3-gdbm-dbg, gdb
# need to turn off apport
Restrictions: needs-root allow-stderr

=== debian/watch ===
version=3
opts=dversionmangle=s/.*\+//,uversionmangle=s/([abcr]+[1-9])$/~$1/ \
  http://www.python.org/ftp/python/3\.4(\.\d)?/Python-(3\.4[.\dabcr]*)\.tgz
